/* -*- mode: C++; c-basic-offset: 2; indent-tabs-mode: nil -*- */
/*
 *  Main authors:
 *     Guido Tack <tack@gecode.org>
 *
 *  Copyright:
 *     Guido Tack, 2014
 *
 *  This file is part of Gecode, the generic constraint
 *  development environment:
 *     http://www.gecode.org
 *
 *  Permission is hereby granted, free of charge, to any person obtaining
 *  a copy of this software and associated documentation files (the
 *  "Software"), to deal in the Software without restriction, including
 *  without limitation the rights to use, copy, modify, merge, publish,
 *  distribute, sublicense, and/or sell copies of the Software, and to
 *  permit persons to whom the Software is furnished to do so, subject to
 *  the following conditions:
 *
 *  The above copyright notice and this permission notice shall be
 *  included in all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 *  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 *  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 *  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 *  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 *  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 *  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef GECODE_TEST_FLATZINC_HH
#define GECODE_TEST_FLATZINC_HH

#include <gecode/kernel.hh>
#include <gecode/flatzinc.hh>

#include "test/test.hh"

#include <string>
#include <vector>

namespace Test {

  /// Tests for FlatZinc
  namespace FlatZinc {

    /**
     * \brief %Base class for tests for FlatZinc
     *
     */
    class FlatZincTest : public Base {
    protected:
      std::string _name;
      std::string _source;
      std::string _expected;
      bool _allSolutions;
      std::vector<std::string> _cmdlineOpt;
    public:
      /// Construct and register test
      FlatZincTest(const std::string& name, const std::string& source,
                   const std::string& expected, bool allSolutions = false,
                   std::vector<std::string> cmdlineOpt = {});
      /// Perform test
      virtual bool run(void);
    };

  }

}

#endif

// STATISTICS: test-flatzinc
